-----------------------------------------------------------------------------
--Assembler Macros       
--altered 5/02 --IMPORTANT-- jump labels in macros must contain '#' character
--                           in them to allow assembler to create individuals                  

--Function prototypes
global sequence 
  f_neg1, f_sqr1, f_sqrt1, f_exp1, f_log1, f_ln1, f_sgn1, f_abs1, f_pwr1,
  f_sin1, f_cos1, f_tan1, f_sincos1, f_sec1, f_cosec1, f_cotan1, f_arcsin1,
  f_arccos1, f_arctan1, f_arctan21, f_sinh1, f_cosh1, f_tanh1, f_cotanh1,--,
  f_mod1, f_rnd1, f_int1
--  f_neg2, f_sqr2, f_sqrt2, f_exp2, f_log2, f_ln2, f_sgn2, f_abs2, f_pwr2,
--  f_sin2, f_cos2, f_tan2, f_sincos2, f_sec2, f_cosec2, f_cotan2, f_arcsin2,
--  f_arccos2, f_arctan2, f_arctan22, f_sinh2, f_cosh2, f_tanh2, f_cotanh2, 
--  f_neg4, f_sqr4, f_sqrt4, f_exp4, f_log4, f_ln4, f_sgn4, f_abs4, f_pwr4,
--  f_sin4, f_cos4, f_tan4, f_sincos4, f_sec4, f_cosec4, f_cotan4, f_arcsin4,
--  f_arccos4, f_arctan4, f_arctan24, f_sinh4, f_cosh4, f_tanh4, f_cotanh4

sequence f_2tox

f_2tox = {"FLD ST(0) \n",
          "FRNDINT \n",
          "FXCH ST(1) \n",
          "FSUB ST(0), ST(1) \n",
          "F2XM1 \n",
          "FLD1 \n",
          "FADDP ST(1), ST(0) \n",
          "FXCH ST(1) \n",
          "FLD1 \n",
          "FSCALE \n",
          "FSTP ST(1) \n",
          "FMULP ST(1), ST(0) \n"}

f_neg1 = {"FCHS \n"}         --neg()

f_sqr1 = {"FMUL ST(0) \n"}   --sqr()

f_sqrt1 = {"FSQRT \n"}       --sqrt()

f_exp1 = {"FLDL2E \n",         --exp()
          "FMULP ST(1), ST(0) \n"} &
          f_2tox

f_log1 = {"FLD1 \n",        --log()
          "FXCH ST(1) \n",
          "FYL2X \n",
          "FLDL2T \n",
          "FDIVRP ST(1), ST(0) \n"}

f_ln1 = {"FLD1 \n",         --ln()
          "FXCH ST(1) \n",
          "FYL2X \n",
          "FLDL2E \n",
          "FDIVRP ST(1), ST(0) \n"}

f_sgn1 = {"FTST \n",         --sgn()
          "FSTSW AX \n",
          "SAHF \n",
          "JZ SGN_ZERO# \n",
          "FLD ST(0) \n",
          "FABS \n",
          "FDIVP ST(1), ST(0) \n",
          "JMP SGN_DONE# \n",
          "SGN_ZERO#: \n",
          "FSTP ST(0) \n",
          "FLD1 \n",
          "SGN_DONE#: \n"}
          
f_abs1 = {"FABS \n"}         --abs()

f_pwr1 = {"FLD1 \n",
          "FXCH ST(1) \n",
          "FABS \n",
          "FYL2X \n",--}&--,
          "FMULP ST(1), ST(0) \n"} &       --power()
           f_2tox

f_sin1 = {"FSIN \n"}         --sin()

f_cos1 = {"FCOS \n"}         --cos()

f_sincos1 = {"FSINCOS \n"}   --sincos()

f_tan1 = {"FPTAN \n",
          "FSTP ST(0) \n"}         --tan()

f_sec1 = {"FCOS \n",         --sec()
          "FLD1 \n",
          "FDIVP ST(1), ST(0) \n"}          

f_cosec1 = {"FSIN \n",         --cosec()
            "FLD1 \n",
            "FDIVP ST(1), ST(0) \n"}        

f_cotan1 = {"FSINCOS \n",      --cotan()
            "FDIVP ST(1), ST(0) \n"}      

f_arcsin1 = {"FLD ST(0) \n",
             "FRNDINT \n",
             "FSUBRP ST(1), ST(0) \n",
             "FMUL ST(0) \n",  --arcsin()
             "FLD ST(0) \n",
             "FLD1 \n",
             "FSUBP ST(1), ST(0) \n",
             "FDIVRP ST(1), ST(0) \n",
             "FSQRT \n",
             "FLD1 \n",
             "FPATAN \n"}

f_arccos1 = {"FLD ST(0) \n",
             "FRNDINT \n",
             "FSUBRP ST(1), ST(0) \n",
             "FMUL ST(0) \n",       --arccos()
             "FLD ST(0) \n",
             "FLD1 \n",
             "FSUBP ST(1), ST(0) \n",
             "FDIVP ST(1), ST(0) \n",
             "FSQRT \n",
             "FLD1 \n",
             "FPATAN \n"}    

f_arctan1 = {"FLD1 \n",
             "FPATAN \n"}       --arctan()

f_arctan21 = {"FPATAN \n"}       --arctan2()

f_sinh1 = {"HypSin not done \n"}       --sinh()

f_cosh1 = {"HypCos not done \n"}       --cosh()

f_tanh1 = {"HypTan not done \n"}       --tanh()

f_cotanh1 = {"HypCotan not done \n"}     --cotanh()

--added 5/02
--bit odd as it is because it appears to be orbital rather than polar
f_mod1 = {"PART_MOD#: \n",
          "FPREM1 \n",
          "FSTSW AX \n",
          "TEST AH, 4 \n",
          "JNZ PART_MOD# \n",
          "FXCH ST(1) \n",
          "FSTP ST(0) \n"}

--random numbers between -1 and 1
--uses special variables as declared below in fpu_constants
f_rnd1 = {"PUSH EDX \n",
          "MOV EAX, DWORD PTR[RAND_SEED] \n",
          "MUL DWORD PTR[RAND_MULT] \n",
          "MOV DWORD PTR[RAND_SEED], EAX \n",
          "POP EDX \n",
          "FILD DWORD PTR[RAND_SEED] \n",
          "FILD DWORD PTR[RAND_MAXINT] \n",
          "FDIVRP ST(1), ST(0) \n"}

f_int1 = {"FRNDINT \n"}

--operators
global sequence 
  o_mul1, o_div1, o_add1, o_sub1--,
--  o_mul2, o_div2, o_add2, o_pwr2,
--  o_mul4, o_div4, o_add4, o_pwr4

o_mul1 = "FMUL"

o_div1 = "FDIV"

o_add1 = "FADD"

o_sub1 = "FSUB"

global sequence fpu_constants

fpu_constants = {{{"const_zero", 1, 0, 0, 0},
                  {"const_one", 1, 1, 0, 0}},
                 {{"pi", 1, pi, 0, 0},
                  {"l2t", 1, l2t, 0, 0},
                  {"l2e", 1, l2e, 0, 0},
                  {"lg2", 1, lg2, 0, 0},
                  {"ln2", 1, ln2, 0, 0},
                  {"RAND_SEED", 4, 123, 0, 1},
                  {"RAND_MULT", 4, 16807, 0, 1},    --16807
                  {"RAND_MAXINT", 4, 2147483647, 0, 1}}, 0}

--end of I80x87.e

