--include vesa20.e
include neil.e
global procedure text_mode() restore_mode() end procedure --uncomment this if vesa20.e absent

include asm.e
include parser.e
set_fp_precision(64)--required as we are hardcoded to qwords below.

constant build = 1
constant frac_asm = "fracasm.e"
constant frac_eng = "engine.e"
--------------------------------------------------------------------------
--data structure..

sequence vars  vars = 
--parameter space in the absence of arrays (23 in total)...
"real a  , b  , c  , d  , e  , f  , g  \n"&
"real a1 , b1 , c1 , d1 , e1 , f1 , g1 \n"&
"real a2 , b2 , c2 , d2 , e2 , f2 , g2 \n"&
"real a3 , b3 , c3 , d3 , e3 , f3 , g3 \n"&
"real a4 , b4 , c4 , d4 , e4 , f4 , g4 \n"&
"real a5 , b5 , c5 , d5 , e5 , f5 , g5 \n"&
"real a6 , b6 , c6 , d6 , e6 , f6 , g6 \n"&
"real a7 , b7 , c7 , d7 , e7 , f7 , g7 \n"&
"real a8 , b8 , c8 , d8 , e8 , f8 , g8 \n"&
"real a9 , b9 , c9 , d9 , e9 , f9 , g9 \n"&
"real a10, b10, c10, d10, e10, f10, g10\n"&
"real a11, b11, c11, d11, e11, f11, g11 \n"&
"real a12, b12, c12, d12, e12, f12, g12 \n"&
"real a13, b13, c13, d13, e13, f13, g13 \n"&
"real a14, b14, c14, d14, e14, f14, g14 \n"&
"real a15, b15, c15, d15, e15, f15, g15 \n"&
"real a16, b16, c16, d16, e16, f16, g16 \n"&
"real a17, b17, c17, d17, e17, f17, g17 \n"&
"real a18, b18, c18, d18, e18, f18, g18 \n"&
"real a19, b19, c19, d19, e19, f19, g19 \n"&
"real a20, b20, c20, d20, e20, f20, g20 \n"&
"real a21, b21, c21, d21, e21, f21, g21 \n"&
"real a22, b22, c22, d22, e22, f22, g22 \n"&
"real a23, b23, c23, d23, e23, f23, g23 \n"&
"int rules, rule \n"& --rule indexing for ifs
--fractal data: 
"real x, y, z, old_x, old_y, old_z \n" &
--transformation vars
"real cos_xy, sin_xy, dist, spot, col, mag \n"&
"real origin_x, origin_y, rot_x, rot_y \n"&
"int iter, iterations \n"&
"byte status, no_min, p1, p2, p3 \n" &
--projection vars
"real centre_x, centre_y, wrp_x, wrp_y, max_r, max_i \n"&
"real size_x, size_y, pnt_x, pnt_y \n"&
--lyapunov data
"real temp_x, temp_y, temp_z, lyap_x, lyap_y, lyap_z, rs \n"&
"real lyap_sum, lyap_result, lyap, million = 1000000 \n"&
"real millionth = .000001, val1, val2 \n"& 
--dimension data
"real ref_x, ref_y, ref_z, dim_max, out_hit, in_hit, dim \n"&
"real out_size = 0.001, in_size = .00001, dim_result \n"&
--hsi2rgb data:
"real hue, saturation, intensity : word red, green, blue \n"&
"int maxint = 255 \n" &
--hsi2rgb jump table:
"int region0, region1, region2, region3, region4, region5, region6 \n"&
--screen data:             
"int xsize, ysize, temp, real_screen, screen_size, page \n"&
--space translation:
"real min_r, min_i, delta_x, delta_y, auto_scl \n"&
"real auto_xl, auto_xh, auto_yl, auto_yh, auto_zl, auto_zh " &
--draw_pixel data:
"int pixels_per_line : byte bits_per_pixel, granularity \n" &
--hitmap data
"int hitmap, hitval : real hits, hit_int, hit_sat, hit_scale = .88 \n" &
--pixlist data
"int pix_list, pixlist_len = 0 \n"&

"real half=0.5, two=2, thirteen=13, ten=10, pt36=0.36, pt8=0.8 \n"&
"real tp4=2.4, pt18=0.18, pt25=0.25 \n"&
"word w1, w2 : int floor"

puts(1, "Declaring variables...\n")
vars = read_variables(vars)

integer bpp, fractal_style
sequence max

max = {640, 480} bpp = 16
fractal_style = 10 --41

--parsing wedge
global function parse(sequence formula)
  sequence result
  if length(formula) = 0 then return "" end if
  result = code_formula(vars, formula)
  if atom(result[1]) then
    text_mode()
    puts(1, result[2] & "\n")
    abort(0)
  end if  
  vars = result[1]
  return result[2]
end function

-----------------------------------------------------------------------------
--Fractals
puts(1, "Compiling fractal types...\n")
include fractals.e

--------------------------------------------------------------------------
--Machine level stuff
  
atom fractal_engine, clearscreen, fractal_insert, shuffle_insert, 
     method_insert, project_insert, clear_maps

sequence thisprog

procedure allocate_fractal()
  sequence code
  code = 
  --  Inside routine
  "pushad \n" &
  "finit " &
  "mov word ptr[temp], 1919 " &--precision control - round down
  "fldcw [temp] " &            --load control word
  "iter_loop: " &
     --iterations test
  "  inc dword ptr[iter] " &
  "  mov eax, dword ptr[iter] " &
  "  cmp eax, dword ptr[iterations] " &
  "  jge frac_done " & 
     --status test
  "  cmp byte ptr[status], 0 " &
  "  jne frac_done " &   
     --perform an iteration
     parse("old_x = x : old_y = y : old_z = z") &
  "  call near shuffle " &
  "  call near iterate " &
  "  call near draw " &        --frame it, translate it then draw
  "  call near test_dynamics " &
  "jmp iter_loop " &
  --time to leave
  "frac_done: " &
  "finit " &                        --clear control word
  "popad \n" &
  "ret \n" &

  ----------------------------------------------------------------------
  -- Code insertion windows

  --iterate() code window
  "iterate: "
  for count = 1 to 1120 do
    code &= "nop \n"
  end for

  --shuffle() code window
  code &= "shuffle: "
  for count = 1 to 256 do
    code &= "nop \n"
  end for

  --method() code window
  code &= "method: "
  for count = 1 to 130 do
    code &= "nop \n"
  end for

  --project() code window
  code &= "project: "
  for count = 1 to 180 do
    code &= "nop \n"
  end for

  ----------------------------------------------------------------------
  -- Fractal dynamics analysis

  --test_dynamics() makes the decision whether to discard the current fractal
  code &=  
  "test_dynamics: " &
   --get magnitude of orbit
  parse("abs(x) + abs(y) + abs(z)") &   --leaves result on fpu stack
  "fcomp qword ptr[million] " &         --compare
  "fstsw ax " &                         --get flags
  "sahf " &                             --set flags
  "jb continue_dyn1 " & 
  "  mov byte ptr[status], 3 " &        --fractal has exploded! dump it
  "  ret " &
  "continue_dyn1: " &
   --get minitude of orbit
  "mov al, [no_min] " &                 --check minitude?
  "cmp al, 0 " &
  "jne continue_dyn2 " &                --nope, go to iter test
     parse("abs(x - old_x) + abs(y - old_y) + abs(z - old_z)") &
  "  fcomp qword ptr[millionth] " &     --compare
  "  fstsw ax " &                       --get flags
  "  sahf " &                           --set flags
  "  ja continue_dyn2 " & 
  "    mov byte ptr[status], 4 " &      --fractal has imploded! dump it
  "    ret " &
  "continue_dyn2: " &
   --test iterations < 1000 before continuing
  "cmp dword ptr[iter], 1000 " &        --compare
  "jb continue_dyn3 " &
  "  ret " &                            --nope, continue the fractal
  "continue_dyn3: "&
   --is lyapunov exponent going to be tested?
  "fld qword ptr[lyap] " &              --get desired lyapunov
  "ftst " &                             --compare with 0
  "fstsw ax " &                         --get flags
  "fstp st(0) " &                       --dispose of lyap
  "sahf " &                             --set flags
  "jnz continue_dyn4 " & 
  "  ret " &                            --nope, continue the fractal
  "continue_dyn4: " &
   --iterate lyapunov calculation
  "call near lyapunov " &
   --time to check results?
  "cmp dword ptr[iter], 900 " &
  "ja continue_dyn5 " &
  "  jmp near continue_dyn7 "&          --nope, go to dimension calculation
  "continue_dyn5: " &
   --first test for desired sign
   parse("w1 = sgn(lyap_result) : w2 = sgn(lyap)")& --get signs into integers
  "mov ax, word ptr[w1] " &             --load lyapunov result's sign
  "cmp ax, word ptr[w2] " &             --and compare it with our desires
  "je continue_dyn6 " &
  "  mov byte ptr[status], 2 " &        --fractal is misbehaving! dump it
  "  ret " &
  "continue_dyn6: " &
   --now test for greater magnitude
   parse("val1 = abs(lyap_result) : val2 = abs(lyap)")&
  "fld qword ptr[val1] " &
  "fcomp qword ptr[val2] " &            --compare the values themselves
  "fstsw ax " &                         --get flags
  "sahf " &                             --set flags
  "ja continue_dyn7 " &
  "  mov byte ptr[status], 2 " &        --fractal is not dynamic enough! dump
  "  ret " &
  "continue_dyn7: " &
   --is fractal dimension going to be tested?
  "fld qword ptr[dim] " &               --get desired dimension
  "ftst " &
  "fstsw ax " &                         --get flags
  "fstp st(0) " &                       --dispose of dim
  "sahf " &                             --set flags
  "jnz continue_dyn8 " & 
  "  ret "&                             --nope, continue the fractal
  "continue_dyn8: " &
   --iterate dimension calculation
  "call near dimension " &
   --time to test results?
  "cmp dword ptr[iter], 900 " &
  "ja continue_dyn9 " &
  "  ret "&                             --nope, continue the fractal
  "continue_dyn9: " &
   --has dimension resolved?
  "fld qword ptr[dim_result] " &        --large dims take time to appear
  "ftst " &                             --and appear as 0 until they do
  "fstsw ax " &                         --get flags
  "sahf " &                             --set flags
  "jnz continue_dyn10 " & 
  "  fstp st(0) " &                     --dump dim_result off fpu
  "  ret " &                            --assume it was large. continue.
  "continue_dyn10: "&
   --test dimension
  "fcomp qword ptr[dim] " &             --compare result with desires
  "fstsw ax " &                         --get flags
  "and ah, 1 " &                        --mask all but 'greater' bit
  "mov byte ptr[status], ah " &         --straight into status
  "ret " &                              -- !it didn't work the other way!?!

  --lyapunov() Successive approximation of Lyapunov exponent.
  -- The exponent is a measure of the chaos or order present in a dynamic
  -- system.  Positive values indicate chaotic behaviour, negative show 
  -- self-ordering - the presence of (possibly chaotic) attractors.
  "lyapunov: " &
  parse("temp_x = x : temp_y = y : temp_z = z : " &
        "old_x = lyap_x : old_y = lyap_y : old_z = lyap_z") &
  "call near iterate " &
  parse("mag = (sqr(x - temp_x) + sqr(y - temp_y) + sqr(z - temp_z)) * 1000000000000 : " &
        "rs = 1 / sqrt(mag) : " &
        "lyap_x = temp_x + rs * (x - temp_x) : " &
        "lyap_y = temp_y + rs * (y - temp_y) : " &
        "lyap_z = temp_z + rs * (z - temp_z) : " &
        "lyap_sum = lyap_sum + log(mag) : " &
        "lyap_result = .721347 * lyap_sum / iter : " &
        "x = temp_x : y = temp_y : z = temp_z") &
  "ret " &      
        
  --dimension() Successive approximation of fractal dimension
  -- the fractal dimension is a measure of the smallest set of spacial 
  -- dimensions the fractal may exist within. 
  "dimension: " &
  "cmp dword ptr[iter], 200 " &
  "jae cont_dim1 " &
  "ret " &
  "cont_dim1: " &
  "cmp dword ptr[iter], 200 " &
  "ja cont_dim2 " &
  parse("dim_max = sqr(auto_xh - auto_xl) + sqr(auto_yh - auto_yl) + sqr(auto_zh - auto_zl) : " &
        "ref_x = x : ref_y = y : ref_z = z") &
  "cont_dim2: " &
  parse("mag = (sqr(x - ref_x) + sqr(y - ref_y) + sqr(z - ref_z)) / dim_max") &
  "fld qword ptr[mag] " &
  "fcom qword ptr[out_size] " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jae cont_dim3 " &
  parse("out_hit = out_hit + 1") &
  "cont_dim3: " &
  "fcom qword ptr[in_size] " &
  "fstsw ax " &                 --get flags
  "fstp st(0) " &               --dispose of mag
  "sahf " &                     --set flags
  "jae cont_dim4 " &
  parse("in_hit = in_hit + 1") &
  "cont_dim4: " &
  parse("dim_result = .434294 * log(out_hit / in_hit)") &
  "ret " &
  
  ----------------------------------------------------------------------
  -- Pixel conversion and drawing functions

  "draw: " &
  --dispose of first 100 iterations
  "cmp dword ptr[iter], 100 " &
  "ja dont_dispose " & 
  "ret " &
  "dont_dispose: " &
  --rotate in fractal space
  parse("rot_x = cos_xy * x - sin_xy * y : rot_y = sin_xy * x + cos_xy * y")&
  --compare delta with zero (uninit.)
  "fld qword ptr[delta_x] " &
  "ftst " &                     
  "fstsw ax " &                 --get flags
  "fstp st(0) " &               --dispose of delta
  "sahf " &                     --set flags
  "jz dont_draw " & 
     --the first 1000 iterations are for dynamics
  "  cmp dword ptr[iter], 1000 " &
  "  ja continue_draw " &
  "    ret "&
  "  continue_draw: " &
  "  call near pixel " &      --check against screen boundary and draw
  "  ret " &
  "dont_draw: " &
  --calc_space at 1000 iterations
  "cmp dword ptr[iter], 1000 " &
  "jge calc_space " & 
  --otherwise test corners
  "jmp near test_corners " &    --100 < x < 1000 goes to auto corners

  --calculate alpha, delta + border (this only happens once at 1000 iter)
  "calc_space: " &
  parse(
        "delta_x = (auto_xh - auto_xl) * auto_scl : " &
        "delta_y = (auto_yh - auto_yl) * auto_scl : " &
        "min_r = auto_xl - delta_x : " &
        "min_i = auto_yl - delta_y : " &
        "max_r = auto_xh + delta_x : " &
        "max_i = auto_yh + delta_y : " &
        "delta_x = xsize / (max_r - min_r) : " &
        "delta_y = ysize / (max_i - min_i): " &
        "centre_x = (auto_xl + auto_xh) / 2 : "&
        "centre_y = (auto_yl + auto_yh) / 2 : "&
        "size_x =  max_r - min_r : "&
        "size_y =  max_i - min_i : "&
        "wrp_x = pi / size_x : " &
        "wrp_y = pi / size_y ")&
  "ret " &

  --test corners
  "test_corners: " &
  --do x first
  "fld qword ptr[rot_x] " &
  --lower x
  "  fcom qword ptr[auto_xl] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  ja test1 " &
  "    fst qword ptr[auto_xl] " &
  "  test1: " &
  --upper x
  "  fcom qword ptr[auto_xh] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  jb test2 " &
  "    fst qword ptr[auto_xh] " &
  "  test2: " &
  --now do y
  "fstp st(0) " &
  "fld qword ptr[rot_y] " &
  --lower y
  "  fcom qword ptr[auto_yl] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  ja test3 " &
  "    fst qword ptr[auto_yl] " &
  "  test3: " &
  --upper y
  "  fcom qword ptr[auto_yh] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  jb test4 " &
  "    fst qword ptr[auto_yh] " &
  "  test4: " &
  --now do z
  "fstp st(0) " &
  "fld qword ptr[z] " &
  --lower z
  "  fcom qword ptr[auto_zl] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  ja test5 " &
  "    fst qword ptr[auto_zl] " &
  "  test5: " &
  --upper z
  "  fcom qword ptr[auto_zh] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  jb test6 " &
  "    fst qword ptr[auto_zh] " &
  "  test6: " &
  --done!
  "fstp st(0) " &
  "ret " &


  --pixel()
  --  performs space translation : pixel = (z - frac_min) * frac_delta
  --  returns relative pixel offset into screen or -1 if off screen
  --  destroys : eax, edx
  --  uses     : 1 fpu register
  --  returns  : pixel offset in edi or -1 if pixel is out of bounds
  --test limits
  "pixel: " &
  --Project onto an object
  "call near project \n" & 
  --Space translation; start with imaginary (y)
  parse("temp = (rot_y - min_i) * delta_y") &
  "mov eax, dword ptr[temp] \n" &       --reload (y) as eax
  "cmp eax, 0 " &                       --(y) < 0 ?
  "jl outside " &                       -- outside.
  "cmp eax, dword ptr[ysize] " &        --(y) >= ysize ?
  "jge outside " &                      -- outside.
  --now do real (x)
  parse("temp = (rot_x - min_r) * delta_x") &
  "mov edi, dword ptr[temp] \n" &       --reload (x) into ebx
  "cmp edi, 0 " &                       --(x) < 0 ?
  "jl outside " &                       -- outside.
  "cmp edi, dword ptr[xsize] " &        --(x) >= xsize ?
  "jge outside " &                      -- outside.
  "mul dword ptr[pixels_per_line] " &   --(y) * pixels_per_line
  "add edi, eax " &                     --edi = (y) * pixels_per_line + x
--  "jmp z_buffer " &                     
  "  call near colourize " &
  "outside: " &
  "ret " &

  --colourize() (as called by pixel())
  "colourize: " &
  --"cmp byte ptr[method], 2 " &
   --test hitmap for hit?
  "mov ebx, edi " &                     --get pixel offset
  "add ebx, [hitmap] " &                --offset into hitmap
  "movzx ecx, byte ptr[ebx] " &         --get hit counter
  "cmp cl, 0 " &                        --pixel not hit yet?
  "ja no_addpix " &                     --yes it has, skip this bit
    --add entry to pixlist
  "  inc dword ptr[pixlist_len] " &     --increment the pixlist counter
  "  mov esi, [pixlist_len] " &         --and grab it
  "  shl esi, 2 " &                     --shift it into a dword ptr
  "  add esi, [pix_list] " &            --and add the pixlist base address
  "  mov [esi], edi " &                 --put the pixel offset in the pixlist
  "no_addpix: "&
  --update hitmap
  "cmp cl, 255 " &                      --maximum hits on this pixel?
  "je hitmap_maxhits " &                --skip pixel..
  "  inc ecx " &                        --increment hits
  "  mov byte ptr[ebx], cl " &          --update pixel hit entry
  "hitmap_maxhits: " &
  --use the hitmap for colouring
  "mov dword ptr[hitval], ecx " &       --store the hits for the pixel
  "fild dword ptr[hitval] " &           --and convert it to float
  "fild dword ptr[maxint] " &           --float the maxint(255) value
  "fdivrp st(1), st(0) " &              --and normalise the hits
  "fstp qword ptr[hits] "&              --and lower half for intensity
  "cmp ecx, 128 " &                     --break hits in half using int val
  "jge hitmap_sat " &                   --use upper half for saturation
     parse("hit_int = hits * hit_scale * two + (1 - hit_scale) : "&
           "hit_sat = 1")&
  "  jmp hitmap_cont1 " &               --continue with intensity
  "hitmap_sat: " &                      --calculate saturation-based colour
     parse("hit_sat = 1 - (hits - half) * two : "&  --nice and simple
           "hit_int = 1")&
  "hitmap_cont1: " &                    --get on with it!
  --find the rgb colour
  "call near method " &
  "call near hsi2rgb " &                --convert HSI to RGB
  --arrange colour into 32 bit register
  "mov dh, 0 " &                        --pad it out
  "mov dl, byte ptr[red] " &            --get red
  "rol edx, 16 " &                      --move to high byte
  "mov dh, byte ptr[green] " &          --get green
  "mov dl, byte ptr[blue] " &           --get blue
  --actually draw the pixel
  "call near mangle_pixel " &           --mangle pixel to match visual
  "call near plot_pixel " &             --and finally make it appear!
  "ret " &

  ----------------------------------------------------------------------
  -- Screen access functions

  --mangle_pixel()
  --  mangles basic rgb pixel to current colour depth
  --  destroys : nothing
  --  uses     : nothing
  --  expects  : bpp value in data
  --             edx = colour (0,r,g,b)
  --             edi = pixel absolute (unscaled)
  --  returns  : mangled colour in edx
  --             scaled offset in edi
  "mangle_pixel: " &
  "cmp byte ptr[bits_per_pixel], 8 " &
  "jne mn_fifteen " &
  --8 bpp
  "ret " &
  "mn_fifteen: " &
  "cmp byte ptr[bits_per_pixel], 15 " &
  "jne mn_sixteen " &
  --15 bpp
  "  ror edx, 16 " & --work on upper word
  "  shr dl, 3 " & --5 bit red
  "  rol edx, 8 " & --now upper byte of lower word
  "  shr dx, 3 " & --5 bit blue
  "  rol edx, 8 " & --low byte, low word
  "  shr edx, 3 " & --5 bit red
  "  shl edi, 1 " &              --multiply by 2
  "ret " &
  "mn_sixteen: " &
  "cmp byte ptr[bits_per_pixel], 16 " &
  "jne mn_twentyfour " &
  --16 bpp
  "  ror edx, 16 " & --work on upper word
  "  shr dl, 3 " & --5 bit red
  "  rol edx, 8 " & --now upper byte of lower word
  "  shr dx, 2 " & --6 bit blue
  "  rol edx, 8 " & --low byte, low word
  "  shr edx, 3 " & --5 bit red
  "  shl edi, 1 " &              --multiply by 2
  "ret " &
  "mn_twentyfour: " &
  "cmp byte ptr[bits_per_pixel], 24 " &
  "jne mn_thirtytwo " &
  --24 bpp
  "  shl edi, 1 " & 
  "  add edi, edi " &            --multiply by 3
  "ret " &
  "mn_thirtytwo: " &
  --32 bpp
  "  shl edi, 2 " &            --multiply by 4
  "ret " &

  --set_page()
  --  Sets the active VGA page
  --  destroys : nothing
  --  uses     : vsreen address in data
  --             granularity in data
  --  expects  : edx = page number
  "set_page: " &
  "cmp edx, dword ptr[page] " &
  "je noset " &
  "mov dword ptr[page], edx " &
  "push eax " &
  "push ebx " &
  "push ecx " &
  "movzx eax, [granularity] " &       --get granularity
  "mul edx " &                      --find appropriate window index
  "mov dx, ax " &                   --set window
  "mov ax, #4F05 " &                --request set page
  "mov bx, 0 " &                    --use window 0
  "int #10 " &                      --call VESA
  "pop ecx " &
  "pop ebx " &
  "pop eax " &
  "noset: " &
  "ret " &

  --plot_pixel()
  --  Plots pre-mangled pixel on screen using current colour depth
  --  destroys : edi
  --  uses     : vsreen address in data
  --  expects  : bpp value in data
  --             edi = pixel absolute (scaled)
  --             edx = colour (0,r,g,b)
  --  returns  : existing pixel in ecx
  "plot_pixel: " &
  "mov esi, [real_screen] " &         --real screen address
  "cmp esi, #A0000 " &              --is page swapping necessary?
  "jne easypixel " &
  --ok, use page swapping  (this code is way slow)
  "  push edx " &
  "  mov edx, edi " &
  "  shr edx, 16 " &
  "  call near set_page " &         --switch to final page
  "  shl edx, 16 " &
  "  sub edi, edx " &
  "  pop edx " &
  --or do it the easy way....
  "easypixel: " &                    
  "cmp byte ptr[bits_per_pixel], 8 " &
  "jne pp_fifteen " &
  --8 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  movzx ecx, byte ptr[edi] " &
  "  mov [edi], dl " &--plot new pixel
  "ret " &
  "pp_fifteen: " &
  "cmp byte ptr[bits_per_pixel], 15 " &
  "je pp_fivesix " &
  "cmp byte ptr[bits_per_pixel], 16 " &
  "jne pp_twentyfour " &
  "pp_fivesix: " &
  --15, 16 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  movzx ecx, word ptr[edi] " & --preserve pixel
  "  mov [edi], dx " &--plot new pixel
  "ret " &
  "pp_twentyfour: " &
  "cmp byte ptr[bits_per_pixel], 24 " &
  "jne pp_thirtytwo " &
  --24 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  movzx cx, byte ptr[edi] " &
  "  rol ecx, 16 " &
  "  mov cx, word ptr[edi + 1] " & --preserve pixel
  "  mov [edi + 1], dx " &--plot new pixel
  "  rol edx, 16 " &
  "  mov [edi], dl " &--plot new pixel
  "ret " &
  "pp_thirtytwo: " &
  --32 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  mov ecx, [edi] " & --preserve pixel
  "  mov [edi], edx " &--plot new pixel
  "ret " &
  
  ----------------------------------------------------------------------
  -- Colour conversion functions

  --fix_unary()
  --  normalizes st(0) -- makes range between 0 and 1
  --  destroys : ax
  --  uses     : 1 extra fpu stack register
  --  expects  : value in st(0)
  --  returns  : fixed value in st(0)
  "fix_unary: " &
  "fld1 " &                     --load 1
  "fxch st(1) " &               --swap them
  "fcom st(1) " &               --compare with operand
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jne part_lp " &              --if operand = 1
  "  fstp st(0) " &               --dispose of 1
  "  ret " &                      --return 1
  "part_lp: " &                 --operand != 1, continue.
  "  fprem1 " &                   --find partial remainder
  "  fstsw ax " &                 --get flags
  "  test ah, 4 " &               --test conditions
  "jnz part_lp " &              --partial result? repeat.
  "fxch st(1) " &               --swap them back
  "fstp st(0) " &               --dispose of 1
  "ftst " &                     --compare remainder with zero 
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jae positive " &             --remainder positive? ok.
  "fld1 " &                     --else load 1,
  "faddp st(1), st(0) " &       --add it and pop it
  "positive: " &
  "ret " &

  --hsi2rgb()
  --  Hue, Saturation, Intensity to Red, Green, Blue
  --  destroys : nothing
  --  uses     : 4 fpu stack registers
  --  expects  : hsi triplet in data:
  --        hue          128 qw *
  --        saturation   136 qw *
  --        intensity    144 qw *
  --        also data pointer in esi
  -- returns   : rgb triplet in data:
  --        red          152 w
  --        green        154 w
  --        blue         156 w
  "hsi2rgb: " &
  "push eax " &
  "push ebx " &
  --get intensity
  "fld qword ptr[intensity] " &         --get intensity
  "call near fix_unary " &              --fix intensity
  "fild dword ptr[maxint] " &        --load RGBMAX
  "fmulp st(1), st(0) " &               --intensity = intensity * RGBMAX
  --get saturation
  "fld qword ptr[saturation] " &         --get saturation
  "ftst " &                             --check for zero saturation..
  "fstsw ax " &                         --get flags
  "sahf " &                             --test flags
  "jnz sat_ok " &                       --saturation != 0 ? ok
     --saturation = 0 ; greyscale
  "  fstp st(0) " &                     --else dispose of saturation
  "  fist word ptr[red] " &       --red = floor(int) 
  "  fist word ptr[green] " &       --green = floor(int)
  "  fistp word ptr[blue] " &      --blue = floor(int)
  "  pop ebx " &
  "  pop eax " &
  "  ret " &
  "sat_ok: " &
  "call near fix_unary " &              --fix saturation
  --get hue
  "fld qword ptr[hue] " &         --get hue
  "call near fix_unary " &              --fix hue
  --divide into colour regions
  "mov dword ptr[temp], 6 " &      --const. 6
  "fild dword ptr[temp] " &        --load const. 6
  "fmulp st(1), st(0) " &               --hue = hue * 6
  "fist dword ptr[temp] " &        --keep region in (esi + 124)
  "call near fix_unary " &              --hue = hue - region (more or less)
  --jump to colour region from table
  "mov ebx, [temp] " &             --ebx = region
  "shl ebx, 2 " &                       --expand as offset
  "add ebx, region0 " &                     --location of jump table
  "mov ebx, [ebx] "&
  "jmp near ebx " &                     --go there
  --colour region 0 (hsi2rgb) : red to yellow
  "region_0: " &
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - hue)
  "fmul st(0), st(1) " &                -- sat * (1 - hue)
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * (1 - hue))
  "fmul st(0), st(2) " &                -- int * (1 - sat * (1 - hue))
  "fistp word ptr[green] "&         --green = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fistp word ptr[red] "&         --red = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 1 (hsi2rgb) : yellow to green
  "region_1: " &                        --region = 1
  "fmul st(0), st(1) " &                -- sat * hue
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * hue)
  "fmul st(0), st(2) " &                -- int * (1 - sat * hue)
  "fistp word ptr[red] "&         --red = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fistp word ptr[green] "&         --green = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 2 (hsi2rgb) : green to aqua
  "region_2: " &                        --region = 2
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - hue)
  "fmul st(0), st(1) " &                -- sat * (1 - hue)
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * (1 - hue))
  "fmul st(0), st(2) " &                -- int * (1 - sat * (1 - hue))
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[red] "&         --red = floor(etc..
  "fistp word ptr[green] "&         --green = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 3 (hsi2rgb) : aqua to blue
  "region_3: " &                        --region = 3
  "fmul st(0), st(1) " &                -- sat * hue
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * hue)
  "fmul st(0), st(2) " &                -- int * (1 - sat * hue)
  "fistp word ptr[green] "&         --green = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[red] "&         --red = floor(etc..
  "fistp word ptr[blue] "&         --blue = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 4 (hsi2rgb) : blue to violet
  "region_4: " &                        --region = 4
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - hue)
  "fmul st(0), st(1) " &                -- sat * (1 - hue)
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * (1 - hue))
  "fmul st(0), st(2) " &                -- int * (1 - sat * (1 - hue))
  "fistp word ptr[red] "&         --red = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[green] "&         --green = floor(etc..
  "fistp word ptr[blue] "&         --blue = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 5 (hsi2rgb) : violet to red
  "region_5: " &                        --region = 5.
  "fmul st(0), st(1) " &                -- sat * hue
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * hue)
  "fmul st(0), st(2) " &                -- int * (1 - sat * hue)
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[green] "&         --green = floor(etc..
  "fistp word ptr[red] "&         --red = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &

  ----------------------------------------------------------------------
  -- External functions
  
  --clear maps
  "clear_maps: " &
  "pushad \n" &
  "mov ecx, dword ptr[pixlist_len] " &
  "cmp ecx, 0 "&
  "je clearmap_exit " &
  "clearmap_loop: " &
    --get index
  "  mov ebx, ecx " &
  "  shl ebx, 2 " &
  "  add ebx, [pix_list] " &
  "  mov eax, [ebx] " &
    --clear hitmap
  "  mov ebx, eax " &
  "  add ebx, [hitmap] "&
  "  mov byte ptr[ebx], 0 " &  
    --clear pixel
  "  push ecx " &
  "  mov edi, eax " &
  "  mov edx, 0 " &
  "  call near mangle_pixel "&
  "  call near plot_pixel " &
  "  pop ecx " &
  "loop clearmap_loop "&
  "mov eax, 0 " &
  "mov [pixlist_len], eax " &
  "clearmap_exit: "&
  "popad \n" &
  "ret \n" & 

  --clear the screen
  "clear_screen: " &
  "pushad \n" &
  "cld " &
  "mov eax, 0 " &
  "mov edi, [real_screen] " &         --real screen address
  "cmp edi, #A0000 " &              --is page swapping necessary?
  "jne easycopy " &
  --ok, use page swapping  (this code is way slow)
  "  mov ebx, [screen_size] " &       --screen size
  "  mov edx, 0 " &
  "  pageloop: " &
  "    call near set_page " &       --update current page
  "    inc edx " & 
  "    mov ecx, 16384 " &           --copy a page of dwords
  "    rep stosd " &
  "    mov edi, [real_screen] " &     --reset real screen address
  "    sub ebx, 65536 " &           --cut a page worth off size
  "    cmp ebx, 65536 " &           --loop if more than a page remaining
  "  ja pageloop " & 
  "  call near set_page " &         --switch to final page
  "  mov ecx, ebx " &               --remaining count
  "  shr ecx, 2 " &                 --div by 4
  "  rep stosd " &                  --copy the rest
  "  jmp endcopy " &
  --or do it the easy way....
  "easycopy: " &                    
  "mov ecx, [screen_size] " &         --screen size
  "shr ecx, 2 " &
  "rep stosd " &                    --copy it all
  "endcopy: " &
  "popad \n" &
  "ret \n" & 
  ""
  if build then 
    asm_output(open(frac_eng,"w"), 3) 
    puts(asm_output_file, "-- NickFrac Fractal engine precompiled include file --\n"&
           "-- engine.e --   Generated by \""& thisprog &"\"\n"&
           "include strnum.e\n")
    puts(asm_output_file, "\n------------------------------------------------------------------------\n"&
             "-- Data access offsets --\n")
    include_vars(asm_output_file, vars)
    puts(asm_output_file, "\n------------------------------------------------------------------------\n"&
             "-- Fractal engine code --\nsequence code  code = \n")
  end if
  puts(1, "Assembling Fractal Engine...")
  code = get_asm(code)
  if not build then
    puts(1, "Allocating Fractal Engine...\n")
    fractal_engine = allocate(length(code))
    poke(fractal_engine, code)             --assemble convert code
  end if
  clear_maps = get_label("clear_maps") 
  clearscreen = get_label("clear_screen") 
  fractal_insert = get_label("iterate") 
  shuffle_insert = get_label("shuffle") 
  method_insert = get_label("method") 
  project_insert = get_label("project") 
  if build then
    printf(asm_output_file, "\n\n--Allocate code segment\n"&
                          "global constant fractal_engine "&
                          "= allocate(%d)\n"&
                          "poke(fractal_engine, code)\n", length(code))
    printf(asm_output_file, "\n------------------------------------------------------------------------\n"&
             "-- Procedure access constants --\n"& 
      "\nglobal constant \n  clear_maps = %d + fractal_engine,\n"&
      "  clearscreen = %d + fractal_engine,\n  fractal_insert = %d + fractal_engine,\n" &
      "  shuffle_insert = %d + fractal_engine,\n  method_insert = %d + fractal_engine,\n" &
      "  project_insert = %d + fractal_engine\n\n--Set up the jump table\n"&
      "poke4(data + REGION0, %d + fractal_engine)\n" & 
      "poke4(data + REGION1, %d + fractal_engine)\n" & 
      "poke4(data + REGION2, %d + fractal_engine)\n" & 
      "poke4(data + REGION3, %d + fractal_engine)\n" & 
      "poke4(data + REGION4, %d + fractal_engine)\n" & 
      "poke4(data + REGION5, %d + fractal_engine)\n" & 
      "poke4(data + REGION6, %d + fractal_engine)\n",
            {clear_maps, clearscreen,
             fractal_insert, shuffle_insert, method_insert,
             project_insert, get_label("region_0"), 
             get_label("region_1"), get_label("region_2"), 
             get_label("region_3"), get_label("region_4"), 
             get_label("region_5"), get_label("region_0")}) 
                            
  else 
    clear_maps += fractal_engine
    clearscreen += fractal_engine
    fractal_insert += fractal_engine
    shuffle_insert += fractal_engine
    method_insert += fractal_engine
    project_insert += fractal_engine
    vars = set_variable(vars, {"region0", "region1", "region2", "region3", 
                             "region4", "region5", "region6"},
                            {get_label("region_0"), get_label("region_1"), 
                             get_label("region_2"), get_label("region_3"), 
                             get_label("region_4"), get_label("region_5"),
                             get_label("region_0")} + fractal_engine) 
  end if
  --printf(asm_output_file, "Runtime location in memory : %x", fractal_engine)
  if build then close(asm_output_file) end if
  puts(1, "OK\n")
  asm_output(-1, 1)       
end procedure


atom hitmap, pix_list, video_len
----------------------------------------------------------------------------
-- Code compilation, assembly and data allocation
if not build then
  puts(1, "Compiling Fractal Engine...\n")
  allocate_fractal()
  puts(1, "Allocating variables...\n")
  vars = allocate_variables(vars)
  --seed random number generator
  vars = set_variable(vars, "RAND_SEED", rand(1073741823)) 

----------------------------------------------------------------------------
--Data initialization
--ok, set mode now...
  if vesa_mode(max[1], max[2], bpp) then puts(1, "No modes!\n") abort(0) end if
  video_len = bytes_per_line * max[2]
--hitmap allocation
  hitmap = allocate(video_len / bytes_per_pixel)
  mem_set(hitmap, 0, video_len / bytes_per_pixel)
--pixlist allocation
  pix_list = allocate(video_len / bytes_per_pixel * 4)
  mem_set(pix_list, 0, video_len / bytes_per_pixel * 4)
--set once stuff
  vars = set_variable(vars, {"real_screen", "screen_size", "pixels_per_line",
                           "bits_per_pixel", "granularity", "xsize", "ysize",
                           "hitmap", "pix_list"},
                          {video_mem, video_len, bytes_per_line / bytes_per_pixel,
                            bits_per_pixel, win_granularity, max[1], max[2],
                            hitmap, pix_list})
  resolve_variables(fractal_engine, vars)
end if
----------------------------------------------------------------------------
--Wedge code

procedure insert_formula(integer style, integer method, integer projection)
  atom fractals, byte, found, nest, comn, ind
  sequence search, code
  if build then 
    --build the fractals
    if style > 0 then
      puts(1, params[style][NAME] & repeat('.', 15 - length(params[style][NAME])))
      asm_output(open(frac_asm,"a"), 3) 
      asm_proc_name = params[style][NAME] & "_shuffle"
      puts(asm_output_file, "\n----==## "& params[style][NAME] &" ##==----\n")
      --get function
      search = " " & params[style][NAME] & "_init"
      fractals = open("fractals.e", "r")
      byte = getc(fractals)
      found = 0
      while 1 do
        if byte != -1 then
          for count = 1 to length(search) do
            if byte = search[count] then
              found = 1
              byte = getc(fractals)
            else exit end if
            if count = length(search) then exit
            else found = 0 end if
          end for  
          if found = 1 then exit end if
          byte = getc(fractals)
        else exit end if
      end while  
      if found then
        puts(asm_output_file, "function " & search & byte)
        search = "end function"
        found = 1
        while found <= length(search) do
          byte = getc(fractals)
          if byte = search[found] then found = found + 1
          else found = 1 end if
          puts(asm_output_file, byte)
        end while    
        comn = 0
        nest = 0
        found = 1
        while 1 do
          byte = getc(fractals)
          if comn = 2 and byte = '\n' then comn = 0 end if
          if comn < 2 then
            if byte = '-' then comn += 1 else comn = 0 end if
            if byte = '{' then nest += 1 end if
            if byte = '}' then nest -= 1 end if
            if nest = 2 and byte = ',' then found += 1 end if  
            end if
          if found = SHUFFLE and byte = '\n' then comn = 0
            puts(asm_output_file, "\n  -- shuffle code --\n")  
            --set up the iter shuffle
            code = get_asm(params[style][SHUFFLE] & "ret \n")
            while 1 do
              byte = getc(fractals)
              if byte = '"' then 
                if nest = 2 then nest = 3 else nest = 2 end if
              end if  
              if nest = 2 and byte = ',' then found += 1 exit end if
            end while
          end if
          if found = ORBIT and byte = '\n' then comn = 0
            puts(asm_output_file, "\n  -- orbit code --\n")  
            --now the actual formula
            code = get_asm(params[style][ORBIT] & "ret \n")
            while 1 do
              byte = getc(fractals)
              if byte = '"' then 
                if nest = 2 then nest = 3 else nest = 2 end if
              end if  
              if nest = 2 and byte = '}' then found += 1 exit end if
            end while  
          end if
          puts(asm_output_file, byte)  
          if found = ORBIT + 1 and nest = 1 then exit end if  
        end while
      end if
      puts(asm_output_file, "\n\n")
      puts(1, "OK\n")
      close(fractals)
      close(asm_output_file) 

    --build the methods
    elsif method > 0 then
      asm_output(open(frac_asm,"a"), 3)
      search = "methods ="
      fractals = open("fractals.e", "r")
      byte = getc(fractals)
      found = 0 ind = 1
      while 1 do
        if byte != -1 then
          if byte = search[ind] then ind += 1
          else ind = 1 end if   
          if ind > length(search) then found = 1 exit end if
          byte = getc(fractals)
        else exit end if
      end while  
      ind = 1
      if found then
        puts(asm_output_file, search)
        found = 0 comn = 0 nest = 0 
        puts(1, methods[ind][1] & repeat('.', 15 - length(methods[ind][1])))
        while byte != -1 do
          byte = getc(fractals)
          if comn = 2 and byte = '\n' then comn = 0 end if
          if comn < 2 then
            if byte = '-' then comn += 1 else comn = 0 end if
            if byte = '{' then nest += 1 end if
            if byte = '}' then nest -= 1 end if
            if nest = 2 and byte = ',' and comn = 0 then found += 1 end if  
          end if
            if found = ind then 
            puts(asm_output_file, byte & "\n")  
            code = get_asm(methods[ind][2] & "ret \n")
            while byte != -1 do
              byte = getc(fractals)
              if byte = '}' then exit end if
            end while
            nest -= 1 ind += 1
            puts(1, "OK\n")
            if ind > length(methods) then exit end if
            puts(1, methods[ind][1] & repeat('.', 15 - length(methods[ind][1])))
          end if
          puts(asm_output_file, byte)  
        end while
        puts(asm_output_file, "}\n}")  
      end if
      puts(asm_output_file, "\n\n")
      close(fractals)
      close(asm_output_file) 

    --build the projections
    elsif projection > 0 then
      asm_output(open(frac_asm,"a"), 3)
      search = "projections ="
      fractals = open("fractals.e", "r")
      byte = getc(fractals)
      found = 0 ind = 1
      while 1 do
        if byte != -1 then
          if byte = search[ind] then ind += 1
          else ind = 1 end if   
          if ind > length(search) then found = 1 exit end if
          byte = getc(fractals)
        else exit end if
      end while  
      ind = 1
      if found then
        puts(asm_output_file, search)
        found = 0 comn = 0 nest = 0
        puts(1, projections[ind][1] & repeat('.', 15 - length(projections[ind][1])))
        while byte != -1 do
          byte = getc(fractals)
          if comn = 2 and byte = '\n' then comn = 0 end if
          if comn < 2 then
            if byte = '-' then comn += 1 else comn = 0 end if
            if byte = '{' then nest += 1 end if
            if byte = '}' then nest -= 1 end if
            if nest = 2 and byte = ',' and comn = 0 then found += 1 end if  
          end if
            if found = ind then 
            puts(asm_output_file, byte & "\n")  
            code = get_asm(projections[ind][2] & "ret \n")
            while byte != -1 do
              byte = getc(fractals)
              if byte = '}' then exit end if
            end while
            nest -= 1 ind += 1
            puts(1, "OK\n")
            if ind > length(projections) then exit end if
            puts(1, projections[ind][1] & repeat('.', 15 - length(projections[ind][1])))
          end if
          puts(asm_output_file, byte)  
        end while
        puts(asm_output_file, "}\n}")  
      end if
      puts(asm_output_file, "\n\n")
      close(fractals)
      close(asm_output_file)
    end if   
  end if

  --actual run time..
  if not build then 
    --set up the iter shuffle
    code = get_asm(params[style][SHUFFLE] & "ret \n")
    if length(code) > 256 then
      printf(1, "Shuffle code in " & params[style][NAME] & " Too long! (%d)\n", length(code))
      abort(0)
    end if
    poke(shuffle_insert, code)
    resolve_variables(shuffle_insert, vars)
    --now the actual formula
    code = get_asm(params[style][ORBIT] & "ret \n")
    if length(code) > 1120 then
      printf(1, "Iterate code in " & params[style][NAME] & " Too long! (%d)\n", length(code))
      abort(0)
    end if
    poke(fractal_insert, code)
    resolve_variables(fractal_insert, vars)
    --then the method
    code = get_asm(methods[method][2] & "ret \n")
    if length(code) > 256 then
      printf(1, "Method code in " & params[style][NAME] & " Too long! (%d)\n", length(code))
      abort(0)
    end if
    poke(method_insert, code)
    resolve_variables(method_insert, vars)
    --finally the projection
    code = get_asm(projections[projection][2] & "ret \n")
    if length(code) > 256 then
      printf(1, "Projection code in " & params[style][NAME] & " Too long! (%d)\n", length(code))
      abort(0)
    end if
    poke(project_insert, code)
    resolve_variables(project_insert, vars)
  end if
end procedure

constant iter_step = 1000

--pointers for fast init
atom iter_ptr, seed_ptr, coef_ptr, trans_ptr, dynl_ptr, proj_ptr,
     rule_ptr, auto_ptr, space_ptr, dynd_ptr, status_ptr
--pointers for fast engine
atom iterations_ptr, lyap_ptr, dim_ptr, numpix_ptr

iter_ptr = get_variable_address(vars, "iter")
seed_ptr = get_variable_address(vars, "x")
rule_ptr = get_variable_address(vars, "rules")
coef_ptr = get_variable_address(vars, "a")
trans_ptr = get_variable_address(vars, "cos_xy")
dynl_ptr = get_variable_address(vars, "lyap_x")
auto_ptr = get_variable_address(vars, "auto_xl")
space_ptr = get_variable_address(vars, "min_r")
dynd_ptr = get_variable_address(vars, "ref_x")
status_ptr = get_variable_address(vars, "status")
iterations_ptr = get_variable_address(vars, "iterations")
lyap_ptr = get_variable_address(vars, "lyap_result")
dim_ptr = get_variable_address(vars, "dim_result")
numpix_ptr = get_variable_address(vars, "pixlist_len")
proj_ptr = get_variable_address(vars, "centre_x")

integer method, projection
procedure init(integer style)
  object delta, values, size
  values = call_func(params[style][INIT], {params[style]})
  --coefficients
  for ct = 1 to length(values[COEF]) do
    poke_float8(coef_ptr + (ct - 1) * 8, values[COEF][ct])
  end for
  --corners
  if atom(values[EDGE]) then  --auto corners
    poke_float8(auto_ptr,{1000000,-1000000,1000000,-1000000,1000000,-1000000})
    poke_float8(space_ptr, {0, 0, 0, 0, values[EDGE]})
  else
    size = values[EDGE][2] - values[EDGE][1]
    delta = max / size
    poke_float8(space_ptr, values[EDGE][1] & delta)
    poke_float8(proj_ptr, (values[EDGE][1] + values[EDGE][2]) / 2 
                & pi / size & values[EDGE][2] & size)
  end if
  --rotation dynamics and colourization
  poke_float8(trans_ptr,
         {cos(values[ANGLE] / 180 * pi), sin(values[ANGLE] / 180 * pi),
          values[DIS], values[SPT], rnd(0, 1), 0} & params[style][ORIGIN])
  poke_float8(dynd_ptr, {0,0,0,0,0,0,params[style][MIN_DIM]})
  poke_float8(dynl_ptr,{values[SEED][1] + 0.000001,values[SEED][2],
              0,0,0,0,params[style][MIN_LYAP]})
  --initial seed vars for 2d
  poke_float8(seed_ptr, {values[SEED][1], values[SEED][2],   0})
  --update seed z and lyap seed z vars if 3d
  if and_bits(params[style][FLAGS], THREED) then
    poke_float8(seed_ptr + 16, values[SEED][3])
    poke_float8(dynl_ptr + 16, values[SEED][3])
  end if
  --reset iterations and status
  poke4(iter_ptr, {0, 0})
  poke(status_ptr, {0, and_bits(params[style][FLAGS], NOMIN)})
end procedure

procedure run_engine()
  integer key, iter, auto, numpix, oldpix
  key = ' ' iter = 0 oldpix = 0
  while key != 27 do
    --continuous iterator
    poke4(iterations_ptr, peek4u(iterations_ptr) + iter_step)
    --start new fractal 
    numpix = peek4u(numpix_ptr)
    if iter >= params[fractal_style][MAXITER] or key = ' ' or 
       (and_bits(params[fractal_style][FLAGS], PIXLIST) and 
       oldpix = numpix and iter > iter_step) then
      --new fractal
      fractal_style = rand(length(params))
      init(fractal_style)
      --choose method
      method = rand(4)
      while not params[fractal_style][COLOUR][method] do
        method = rand(4)
      end while
      --choose projection
      if params[fractal_style][PROJECT] then projection = rand(7)
      else projection = 1 end if
      insert_formula(fractal_style, method, projection)
      auto = atom(params[fractal_style][CORNERS])
    end if

    --clear screen when needed
    iter = peek4u(iter_ptr)
    if ((not auto) and iter = 0) or (auto and iter = iter_step) then 
    --use either this.. (should be faster with VESA 2.0 or linear modes)
      call(clear_maps)
      set_page(floor(video_len / 65536))  --page juggling for clear_maps
    --or these...       (better for VESA 1.2 banked modes on my thinkpad)
      --call(clearscreen)
      --mem_set(hitmap, 0, video_len / bytes_per_pixel)
      --poke4(numpix_ptr, 0) --pixmap grows uncontrollably without this!
    --
      position(29, 64 - length(params[fractal_style][NAME]) 
                      - length(projections[projection][1])
                      - length(methods[method][1]))
      puts(1, "     " & params[fractal_style][NAME] & 
              " using " & methods[method][1] & 
              " on " & projections[projection][1])
    end if

    --do iter_step iterations
    call(fractal_engine)
    
    if peek(status_ptr) then
      --fractal has been rejected
      init(fractal_style)
    end if
    
    oldpix = numpix 
    key = get_key()
  end while  
end procedure

atom fn, fc, c, xit
if not build then run_engine() else
  thisprog = command_line() thisprog = thisprog[2]
  puts(1, "Building include files...\n")
  if build > 1 then
    puts(1, "\n-- Building \"engine.e\" --\n")
    allocate_fractal()
    puts(1, "Done.\n")
  end if
  puts(1, "\n-- Building \"fracasm.e\" --")
  fn = open(frac_asm, "w")
  puts(fn, "-- NickFrac Fractal definitions precompiled include file --\n"&
           "-- fracasm.e --   Generated by \""& thisprog &"\"\n"&
           "-- from the fractals definition file \"fractals.e\"\n")
  fc = open("fractals.e", "r")
  xit = 0
  while xit < 2 do
    c = getc(fc)
    if c = '@' then xit += 1 end if
    puts(fn, c)
  end while
  close(fc)  
  puts(fn, "------------------------------------------------------------------------\n"&
           "-- Methods and Projections --\n")
  close(fn)
  puts(1, "\n-- Methods --\n")
  insert_formula(0, 1, 0)
  puts(1, "\n-- Projections --\n")
  insert_formula(0, 0, 1)
  fn = open(frac_asm, "a")
  puts(fn, "\n----------------------------------------------------------------------------\n"&
           "-- Fractal definitions --\n")
  close(fn)
  puts(1, "\n-- Fractals --\n")
  for count = 1 to length(params) do
    insert_formula(count, 0, 0)
  end for
  fn = open(frac_asm, "a")
  puts(fn, "\nnum_frac = length(params)\n-- End of fracasm.e --\n")
  close(fn)
  puts(1, "Done.\n\n")
end if

