include vesa20.e
include asm.e
--include vesamous.e
include parser.e
set_fp_precision(64)--required as we are hardcoded to qwords below.


--------------------------------------------------------------------------
constant freedom = 26
--return decimal random number between l & h
function rnd(atom l, atom h)
  return (rand(freedom) - 1) / (freedom - 1) * (h - l) + l
end function
--------------------------------------------------------------------------
sequence frac_min, frac_max, delta
integer iterations
integer video_len, bpp
sequence max


--
--max = {320, 200}
--max = {320, 240}
--max = {400, 300} --xx
--max = {320, 400}
--max = {320, 480}
--max = {512, 384} --xx
--max = {640, 350}
--max = {640, 400}
max = {640, 480}
--max = {800, 600}
--bpp = 8
--bpp = 15
bpp = 16
--bpp = 24
--bpp = 32

--frac_min = {-2.0, -1.6}
--frac_max = {2.0, 1.6}
frac_min = {-15, -10}
frac_max = {15, 10}
iterations = 50000

--delta = max / (frac_max - frac_min)
delta = {0, 0}


--data structure..
sequence vars

vars = 
--fractal data: 
"real x, y, z, old_x, old_y, old_z \n" &
"real a, b, c, d, e, f \n"&
"real cos_xy, sin_xy, dist, spot, origin_x, origin_y, mag \n"&
"int iter, iterations \n"&
"byte status \n" &
--lyapunov data
"real temp_x, temp_y, temp_z, lyap_x, lyap_y, lyap_z, rs \n"&
"real lyap_sum, lyap_result, lyap, million = 1000000 \n"&
"real millionth = .000001, val1, val2 \n"& 
--dimension data
"real ref_x, ref_y, ref_z, dim_max, out_hit, in_hit, dim \n"&
"real out_size = 0.001, in_size = .00001, dim_result \n"&
--hsi2rgb data:
"real hue, saturation, intensity : word red, green, blue \n"&
--hsi2rgb jump table:
"int region0, region1, region2, region3, region4, region5, region6 \n"&
--screen data:             
"int xsize, ysize, temp, real_screen, screen_size, page \n"&
--space translation:
"real min_r, min_i, delta_x, delta_y \n"&
"real auto_xl, auto_xh, auto_yl, auto_yh, auto_zl, auto_zh " &
--draw_pixel data:
"int pixels_per_line : byte bits_per_pixel, granularity \n"

vars = read_variables(vars)


function parse(sequence formula)
  sequence result
  result = code_formula(vars, formula)
  if atom(result[1]) then
    text_mode()
    puts(1, result[2] & "\n")
    abort(0)
  end if  
  vars = result[2]
  return result[1]
end function
  
asm_output(open("ss3.asm","w"), 1)       
atom fractal_engine, fractal_clear
sequence code
code = get_asm(

--procedure allocate_fractal(sequence formula, atom method)
--  sequence code
--  code = 
  --  Inside routine
  "pushad \n" &
  "finit " &
  "mov word ptr[temp], 1919 " &--precision control - round down
  "fldcw [temp] " &            --load control word
  "iter_loop: " &
     --iterations test
  "  inc dword ptr[iter] " &
  "  mov eax, dword ptr[iter] " &
  "  cmp eax, dword ptr[iterations] " &
  "  jge frac_done " & 
     --status test
  "  cmp byte ptr[status], 0 " &
  "  jne frac_done " &   
     parse("old_x = x : old_y = y : old_z = z") &
  "  call near iterate " &
  "  call near draw " &        --frame it, translate it then draw
  "  call near dynamics " &
  "jmp iter_loop " &
  "frac_done: " &
  "finit " &                        --clear control word
  "popad \n" &
  "ret \n" &

  "iterate: " &

--  parse("x = 1 + old_y - a * sqr(old_x) : y = b * old_x")&

--   parse("x = 1 - old_y + a * abs(old_x) : y = old_x") &--ginger

   parse("e = a - c / (1 + sqr(old_x) + sqr(old_y)) : " &--ikeda
         "x = d + b * (old_x * cos(e) - old_y * sin(e)) :" &
         "y = b * (old_x * sin(e) + old_y * cos(e))")&
  "ret " &
  
  
  "dynamics: " &
  --is dynamics to be tested?
  "fld qword ptr[lyap] " &
  "ftst " &
  "fstsw ax " &                 --get flags
  "fstp st(0) " &               --dispose of lyap
  "sahf " &                     --set flags
  "jnz continue_dyn1 " & 
  "  ret " &
  "continue_dyn1: " &
  --get magnitude of orbit
  parse("abs(x) + abs(y) + abs(z)") &  --leaves result on fpu stack
  "fcomp qword ptr[million] " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jb continue_dyn2 " & 
  "  mov byte ptr[status], 1 " &
  "  ret " &
  "continue_dyn2: " &
  --get minitude of orbit
  parse("abs(x - old_x) + abs(y - old_y) + abs(z - old_z)") &
  "fcomp qword ptr[millionth] " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "ja continue_dyn3 " & 
  "  mov byte ptr[status], 1 " &
  "  ret " &
  "continue_dyn3: " &
  --test iterations
  "cmp dword ptr[iter], 1000 " &
  "jb continue_dyn4 " &
  "  ret " &
  "continue_dyn4: "&
  --calculate lyapunov
  "call near lyapunov " &
   parse("val1 = sgn(lyap_result) : val2 = sgn(lyap)")&
  "fld qword ptr[val1] " &
  "fcomp qword ptr[val2] " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "je continue_dyn5 " &
  "  mov byte ptr[status], 1 " &
  "  ret " &
  "continue_dyn5: " &
   parse("val1 = abs(lyap_result) : val2 = abs(lyap)")&
  "fld qword ptr[val1] " &
  "fcomp qword ptr[val2] " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "ja continue_dyn6 " &
  "  mov byte ptr[status], 1 " &
  "  ret " &
  "continue_dyn6: " &
  --need to test dimension?
  "fld qword ptr[dim] " &
  "ftst " &
  "fstsw ax " &                 --get flags
  "fstp st(0) " &               --dispose of dim
  "sahf " &                     --set flags
  "jnz continue_dyn7 " & 
  "  ret "&
  "continue_dyn7: " &
  --calculate dimension
  "call near dimension " &
  "fld qword ptr[dim_result] " &
  "ftst " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jnz continue_dyn8 " & 
  "  fstp st(0) " &
  "  ret " &
  "continue_dyn8: "&
  --test dimension
  "fcomp qword ptr[dim] " &
  "fstsw ax " &                 --get flags
  "mov byte ptr[status], ah " &
  "ret " &

  --colourize() (as called by pixel())
  "colourize: " &
--  if method = 1 then
  parse("hue = sqrt(sqr(x - old_x) + sqr(y - old_y)) / 10 : " &
        "saturation = 1 : " &
        "intensity = 1") &
  "call near hsi2rgb " &                    --convert HSI to RGB
  "mov dh, 0 " &                            --pad to 32 bits
  "mov dl, byte ptr[red] " &          --get red
  "rol edx, 16 " &                          --move to high byte
  "mov dh, byte ptr[green] " &          --get green
  "mov dl, byte ptr[blue] " &          --get blue
  "mov edi, eax " &           --get pixel offset
  "call near mangle_pixel " &
  "call near plot_pixel " &
  "ret " &

  "lyapunov: " &
  parse("temp_x = x : temp_y = y : temp_z = z : " &
        "old_x = lyap_x : old_y = lyap_y : old_z = lyap_z") &
  "call near iterate " &
  parse("mag = (sqr(x - temp_x) + sqr(y - temp_y) + sqr(z - temp_z)) * 1000000000000 : " &
        "rs = 1 / sqrt(mag) : " &
        "lyap_x = temp_x + rs * (x - temp_x) : " &
        "lyap_y = temp_y + rs * (y - temp_y) : " &
        "lyap_z = temp_z + rs * (z - temp_z) : " &
        "lyap_sum = lyap_sum + log(mag) : " &
        "lyap_result = .721347 * lyap_sum / iter : " &
        "x = temp_x : y = temp_y : z = temp_z") &
  "ret " &      
        
  "dimension: " &
  "cmp dword ptr[iter], 200 " &
  "jae cont_dim1 " &
  "ret " &
  "cont_dim1: " &
  "cmp dword ptr[iter], 200 " &
  "ja cont_dim2 " &
  parse("dim_max = sqr(auto_xh - auto_xl) + sqr(auto_yh - auto_yl) + sqr(auto_zh - auto_zl) : " &
        "ref_x = x : ref_y = y : ref_z = z") &
  "cont_dim2: " &
  parse("mag = (sqr(x - ref_x) + sqr(y - ref_y) + sqr(z - ref_z)) / dim_max") &
  "fld qword ptr[mag] " &
  "fcom qword ptr[out_size] " &
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jae cont_dim3 " &
  parse("out_hit = out_hit + 1") &
  "cont_dim3: " &
  "fcom qword ptr[in_size] " &
  "fstsw ax " &                 --get flags
  "fstp st(0) " &               --dispose of mag
  "sahf " &                     --set flags
  "jae cont_dim4 " &
  parse("in_hit = in_hit + 1") &
  "cont_dim4: " &
  parse("dim_result = .434294 * log(out_hit / in_hit)") &
  "ret " &
  
  ----------------------------------------------------------------------
  -- Fractal space functions

  "draw: " &
  "fld qword ptr[delta_x] " &
  "ftst " &                     --compare delta with zero (uninit.)
  "fstsw ax " &                 --get flags
  "fstp st(0) " &               --dispose of delta
  "sahf " &                     --set flags
  "jz dont_draw " & 
  "  call near translate " &
  "  call near pixel " &           --check against screen boundary and draw
  "  ret " &
  "dont_draw: " &
  "cmp dword ptr[iter], 100 " &
  "ja dont_dispose " & --dispose of first 100 iterations
  "ret " &
  "dont_dispose: " &
  "cmp dword ptr[iter], 1000 " &
  "ja calc_space " & 
  "jmp near test_corners " &--100 <= x <= 5000 goes to auto corners
  "calc_space: " &
  --calculate alpha & delta + 10% border (this only happens once)
  parse("delta_x = (auto_xh - auto_xl) * 0.1 : " &
        "delta_y = (auto_yh - auto_yl) * 0.1 : " &
        "min_r = auto_xl - delta_x : " &
        "min_i = auto_yl - delta_y : " &
        "delta_x = xsize / ((auto_xh + delta_x) - min_r) : " &
        "delta_y = ysize / ((auto_yh + delta_y) - min_i)") &
  "ret " &

  --test corners
  "test_corners: " &
  --do x first
  "fld qword ptr[x] " &
  --lower x
  "  fcom qword ptr[auto_xl] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  ja test1 " &
  "    fst qword ptr[auto_xl] " &
  "  test1: " &
  --upper x
  "  fcom qword ptr[auto_xh] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  jb test2 " &
  "    fst qword ptr[auto_xh] " &
  "  test2: " &
  --now do y
  "fstp st(0) " &
  "fld qword ptr[y] " &
  --lower y
  "  fcom qword ptr[auto_yl] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  ja test3 " &
  "    fst qword ptr[auto_yl] " &
  "  test3: " &
  --upper y
  "  fcom qword ptr[auto_yh] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  jb test4 " &
  "    fst qword ptr[auto_yh] " &
  "  test4: " &
  --now do z
  "fstp st(0) " &
  "fld qword ptr[z] " &
  --lower z
  "  fcom qword ptr[auto_zl] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  ja test5 " &
  "    fst qword ptr[auto_zl] " &
  "  test5: " &
  --upper z
  "  fcom qword ptr[auto_zh] " &
  "  fstsw ax " &                 --get flags
  "  sahf " &                     --set flags
  "  jb test6 " &
  "    fst qword ptr[auto_zh] " &
  "  test6: " &
  --done!
  "fstp st(0) " &
  "ret " &

  --translate()
  --  performs space translation : pixel = (z - frac_min) * frac_delta
  --  destroys : ebx, ecx, edx
  --  uses     : 1 fpu register
  --  returns  : y-coordinate in ebx, x-coordinate in ecx
  "translate: " &
  --Space translation; start with imaginary (y)
  parse("temp = (y - min_i) * delta_y") &
  "mov ebx, dword ptr[temp] \n" &  --reload (y) as eax
  --now do real (x)
  parse("temp = (x - min_r) * delta_x") &
  "mov ecx, dword ptr[temp] \n" &  --reload (x) into ebx
  "ret " &
  
  ----------------------------------------------------------------------
  -- Screen functions

  --bounds()
  --  returns relative pixel offset into screen or -1 if off screen
  --  destroys : eax, edx
  --  uses     : 1 fpu register
  --  returns  : pixel offset in eax or -1 if pixel is out of bounds
  --test limits
  "pixel: " &
  "cmp ebx, 0 " &                       --(y) < 0 ?
  "jl outside " &                       -- outside.
  "cmp ebx, dword ptr[ysize] " &     --(y) >= ysize ?
  "jge outside " &                      -- outside.
  "cmp ecx, 0 " &                       --(x) < 0 ?
  "jl outside " &                       -- outside.
  "cmp ecx, dword ptr[xsize] " &     --(x) >= xsize ?
  "jge outside " &                      -- outside.
  "mov eax, ebx " &
  "mul dword ptr[pixels_per_line] " &         --(y) * pixels_per_line
  "add eax, ecx " &                     --eax = (y) * pixels_per_line + x
  "call near colourize " &
  "outside: " &
  "ret " &

  --mangle_pixel()
  --  mangles basic rgb pixel to current colour depth
  --  destroys : nothing
  --  uses     : nothing
  --  expects  : bpp value in data
  --             edx = colour (0,r,g,b)
  --             edi = pixel absolute (unscaled)
  --  returns  : mangled colour in edx
  --             scaled offset in edi
  "mangle_pixel: " &
  "cmp byte ptr[bits_per_pixel], 8 " &
  "jne mn_fifteen " &
  --8 bpp
  "ret " &
  "mn_fifteen: " &
  "cmp byte ptr[bits_per_pixel], 15 " &
  "jne mn_sixteen " &
  --15 bpp
  "  ror edx, 16 " & --work on upper word
  "  shr dl, 3 " & --5 bit red
  "  rol edx, 8 " & --now upper byte of lower word
  "  shr dx, 3 " & --5 bit blue
  "  rol edx, 8 " & --low byte, low word
  "  shr edx, 3 " & --5 bit red
  "  shl edi, 1 " &              --multiply by 2
  "ret " &
  "mn_sixteen: " &
  "cmp byte ptr[bits_per_pixel], 16 " &
  "jne mn_twentyfour " &
  --16 bpp
  "  ror edx, 16 " & --work on upper word
  "  shr dl, 3 " & --5 bit red
  "  rol edx, 8 " & --now upper byte of lower word
  "  shr dx, 2 " & --6 bit blue
  "  rol edx, 8 " & --low byte, low word
  "  shr edx, 3 " & --5 bit red
  "  shl edi, 1 " &              --multiply by 2
  "ret " &
  "mn_twentyfour: " &
  "cmp byte ptr[bits_per_pixel], 24 " &
  "jne mn_thirtytwo " &
  --24 bpp
  "  shl edi, 1 " & 
  "  add edi, edi " &            --multiply by 3
  "ret " &
  "mn_thirtytwo: " &
  --32 bpp
  "  shl edi, 2 " &            --multiply by 4
  "ret " &

  --set_page()
  --  Sets the active VGA page
  --  destroys : nothing
  --  uses     : vsreen address in data
  --             granularity in data
  --  expects  : edx = page number
  "set_page: " &
  "cmp edx, dword ptr[page] " &
  "je noset " &
  "mov dword ptr[page], edx " &
  "push eax " &
  "push ebx " &
  "push ecx " &
  "movzx eax, [granularity] " &       --get granularity
  "mul edx " &                      --find appropriate window index
  "mov dx, ax " &                   --set window
  "mov ax, #4F05 " &                --request set page
  "mov bx, 0 " &                    --use window 0
  "int #10 " &                      --call VESA
  "pop ecx " &
  "pop ebx " &
  "pop eax " &
  "noset: " &
  "ret " &

  --plot_pixel()
  --  Plots pre-mangled pixel on screen using current colour depth
  --  destroys : edi
  --  uses     : vsreen address in data
  --  expects  : bpp value in data
  --             edi = pixel absolute (scaled)
  --             edx = colour (0,r,g,b)
  --  returns  : existing pixel in ecx
  "plot_pixel: " &
  "mov esi, [real_screen] " &         --real screen address
  "cmp esi, #A0000 " &              --is page swapping necessary?
  "jne easypixel " &
  --ok, use page swapping  (this code is way slow)
  "  push edx " &
  "  mov edx, edi " &
  "  shr edx, 16 " &
  "  call near set_page " &         --switch to final page
  "  shl edx, 16 " &
  "  sub edi, edx " &
  "  pop edx " &
  --or do it the easy way....
  "easypixel: " &                    
  "cmp byte ptr[bits_per_pixel], 8 " &
  "jne pp_fifteen " &
  --8 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  movzx ecx, byte ptr[edi] " &
  "  mov [edi], dl " &--plot new pixel
  "ret " &
  "pp_fifteen: " &
  "cmp byte ptr[bits_per_pixel], 15 " &
  "je pp_fivesix " &
  "cmp byte ptr[bits_per_pixel], 16 " &
  "jne pp_twentyfour " &
  "pp_fivesix: " &
  --15, 16 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  movzx ecx, word ptr[edi] " & --preserve pixel
  "  mov [edi], dx " &--plot new pixel
  "ret " &
  "pp_twentyfour: " &
  "cmp byte ptr[bits_per_pixel], 24 " &
  "jne pp_thirtytwo " &
  --24 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  movzx cx, byte ptr[edi] " &
  "  rol ecx, 16 " &
  "  mov cx, word ptr[edi + 1] " & --preserve pixel
  "  mov [edi + 1], dx " &--plot new pixel
  "  rol edx, 16 " &
  "  mov [edi], dl " &--plot new pixel
  "ret " &
  "pp_thirtytwo: " &
  --32 bpp
  "  add edi, [real_screen] " &     --offset into screen address
  "  mov ecx, [edi] " & --preserve pixel
  "  mov [edi], edx " &--plot new pixel
  "ret " &
  
  ----------------------------------------------------------------------
  -- Colour functions

  --fix_unary()
  --  normalizes st(0) -- makes range between 0 and 1
  --  destroys : ax
  --  uses     : 1 extra fpu stack register
  --  expects  : value in st(0)
  --  returns  : fixed value in st(0)
  "fix_unary: " &
  "fld1 " &                     --load 1
  "fxch st(1) " &               --swap them
  "fcom st(1) " &               --compare with operand
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jne part_lp " &              --if operand = 1
  "  fstp st(0) " &               --dispose of 1
  "  ret " &                      --return 1
  "part_lp: " &                 --operand != 1, continue.
  "  fprem1 " &                   --find partial remainder
  "  fstsw ax " &                 --get flags
  "  test ah, 4 " &               --test conditions
  "jnz part_lp " &              --partial result? repeat.
  "fxch st(1) " &               --swap them back
  "fstp st(0) " &               --dispose of 1
  "ftst " &                     --compare remainder with zero 
  "fstsw ax " &                 --get flags
  "sahf " &                     --set flags
  "jae positive " &             --remainder positive? ok.
  "fld1 " &                     --else load 1,
  "faddp st(1), st(0) " &       --add it and pop it
  "positive: " &
  "ret " &

  --hsi2rgb()
  --  Hue, Saturation, Intensity to Red, Green, Blue
  --  destroys : nothing
  --  uses     : 4 fpu stack registers
  --  expects  : hsi triplet in data:
  --        hue          128 qw *
  --        saturation   136 qw *
  --        intensity    144 qw *
  --        also data pointer in esi
  -- returns   : rgb triplet in data:
  --        red          152 w
  --        green        154 w
  --        blue         156 w
  "hsi2rgb: " &
  "push eax " &
  "push ebx " &
  --get intensity
  "fld qword ptr[intensity] " &         --get intensity
  "call near fix_unary " &              --fix intensity
  "mov dword ptr[temp], 255 " &    --const. 255 into temp (RGBMAX)
  "fild dword ptr[temp] " &        --load RGBMAX
  "fmulp st(1), st(0) " &               --intensity = intensity * RGBMAX
  --get saturation
  "fld qword ptr[saturation] " &         --get saturation
  "ftst " &                             --check for zero saturation..
  "fstsw ax " &                         --get flags
  "sahf " &                             --test flags
  "jnz sat_ok " &                       --saturation != 0 ? ok
     --saturation = 0 ; greyscale
  "  fstp st(0) " &                     --else dispose of saturation
  "  fist word ptr[red] " &       --red = floor(int) 
  "  fist word ptr[green] " &       --green = floor(int)
  "  fistp word ptr[blue] " &      --blue = floor(int)
  "  pop ebx " &
  "  pop eax " &
  "  ret " &
  "sat_ok: " &
  "call near fix_unary " &              --fix saturation
  --get hue
  "fld qword ptr[hue] " &         --get hue
  "call near fix_unary " &              --fix hue
  --divide into colour regions
  "mov dword ptr[temp], 6 " &      --const. 6
  "fild dword ptr[temp] " &        --load const. 6
  "fmulp st(1), st(0) " &               --hue = hue * 6
  "fist dword ptr[temp] " &        --keep region in (esi + 124)
  "call near fix_unary " &              --hue = hue - region (more or less)
  --jump to colour region from table
  "mov ebx, [temp] " &             --ebx = region
  
--  "pop ebx " &
--  "pop eax " &
--  "ret " &

  "shl ebx, 2 " &                       --expand as offset
  "add ebx, region0 " &                     --location of jump table
  "mov ebx, [ebx] "&
  "jmp near ebx " &                     --go there
  --colour region 0 (hsi2rgb) : red to yellow
  "region_0: " &
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - hue)
  "fmul st(0), st(1) " &                -- sat * (1 - hue)
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * (1 - hue))
  "fmul st(0), st(2) " &                -- int * (1 - sat * (1 - hue))
  "fistp word ptr[green] "&         --green = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fistp word ptr[red] "&         --red = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 1 (hsi2rgb) : yellow to green
  "region_1: " &                        --region = 1
  "fmul st(0), st(1) " &                -- sat * hue
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * hue)
  "fmul st(0), st(2) " &                -- int * (1 - sat * hue)
  "fistp word ptr[red] "&         --red = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fistp word ptr[green] "&         --green = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 2 (hsi2rgb) : green to aqua
  "region_2: " &                        --region = 2
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - hue)
  "fmul st(0), st(1) " &                -- sat * (1 - hue)
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * (1 - hue))
  "fmul st(0), st(2) " &                -- int * (1 - sat * (1 - hue))
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[red] "&         --red = floor(etc..
  "fistp word ptr[green] "&         --green = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 3 (hsi2rgb) : aqua to blue
  "region_3: " &                        --region = 3
  "fmul st(0), st(1) " &                -- sat * hue
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * hue)
  "fmul st(0), st(2) " &                -- int * (1 - sat * hue)
  "fistp word ptr[green] "&         --green = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[red] "&         --red = floor(etc..
  "fistp word ptr[blue] "&         --blue = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 4 (hsi2rgb) : blue to violet
  "region_4: " &                        --region = 4
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - hue)
  "fmul st(0), st(1) " &                -- sat * (1 - hue)
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * (1 - hue))
  "fmul st(0), st(2) " &                -- int * (1 - sat * (1 - hue))
  "fistp word ptr[red] "&         --red = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[green] "&         --green = floor(etc..
  "fistp word ptr[blue] "&         --blue = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &
  --colour region 5 (hsi2rgb) : violet to red
  "region_5: " &                        --region = 5.
  "fmul st(0), st(1) " &                -- sat * hue
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat * hue)
  "fmul st(0), st(2) " &                -- int * (1 - sat * hue)
  "fistp word ptr[blue] "&         --blue = floor(etc..
  "fld1 " &
  "fsubp st(1), st(0) " &               -- (1 - sat)
  "fmul st(0), st(1) " &                -- int * (1 - sat)
  "fistp word ptr[green] "&         --green = floor(etc..
  "fistp word ptr[red] "&         --red = floor(int)
  "pop ebx " &
  "pop eax " &
  "ret " &

  ----------------------------------------------------------------------
  -- External functions

  --screencopy() 
  --  Copies the virtual screen to the screen
  --  destroys : nothing
  --  uses     : nothing
  --  expects  : nothing
  --  returns  : nothing
  "clearscreen: " &
  "pushad \n" &
  "cld " &
  "mov eax, 0 " &
  "mov edi, [real_screen] " &         --real screen address
  "cmp edi, #A0000 " &              --is page swapping necessary?
  "jne easycopy " &
  --ok, use page swapping  (this code is way slow)
  "  mov ebx, [screen_size] " &       --screen size
  "  mov edx, 0 " &
  "  pageloop: " &
  "    call near set_page " &       --update current page
  "    inc edx " & 
  "    mov ecx, 16384 " &           --copy a page of dwords
  "    rep stosd " &
  "    mov edi, [real_screen] " &     --reset real screen address
  "    sub ebx, 65536 " &           --cut a page worth off size
  "    cmp ebx, 65536 " &           --loop if more than a page remaining
  "  ja pageloop " & 
  "  call near set_page " &         --switch to final page
  "  mov ecx, ebx " &               --remaining count
  "  shr ecx, 2 " &                 --div by 4
  "  rep stosd " &                  --copy the rest
  "  jmp endcopy " &
  --or do it the easy way....
  "easycopy: " &                    
  "mov ecx, [screen_size] " &         --screen size
  "shr ecx, 2 " &
  "rep stosd " &                    --copy it all
  "endcopy: " &
  "popad \n" &
  "ret \n" & 

  "")
fractal_engine = allocate(length(code))  poke(fractal_engine, code)

printf(asm_output_file, "Runtime location in memory : %x", fractal_engine)
close(asm_output_file)

----------------------------------------------------------------------------
--Video access
--ok, set mode now...
if vesa_mode(max[1], max[2], bpp) then puts(1, "No modes!\n") abort(0) end if
video_len = bytes_per_line * max[2]
--set_vesa_mouse()


----------------------------------------------------------------------------
--Data initialization
fractal_clear = get_label("clearscreen") + fractal_engine

vars = set_variable(vars, {"region0", "region1", "region2", "region3", 
                           "region4", "region5", "region6"},
                          {get_label("region_0"), get_label("region_1"), 
                           get_label("region_2"), get_label("region_3"), 
                           get_label("region_4"), get_label("region_5"),
                           get_label("region_0")} + fractal_engine) 

vars = set_variable(vars, {"real_screen", "screen_size", "pixels_per_line",
                           "bits_per_pixel", "granularity", "xsize", "ysize"}, 
                          {video_mem, video_len, bytes_per_line / bytes_per_pixel,
                            bits_per_pixel, win_granularity, max[1], max[2]}) 

----------------------------------------------------------------------------
-- Data allocation
vars = allocate_variables(vars)
resolve_variables(fractal_engine, vars)


procedure init()
  atom a, b, c, d
  a = rnd(-50, 50) b = 1--.00001 
  c = 0 
  while c > -3.6 and c < 3.6 do
    c = rnd(-50, 50)
  end while
  d = 0
  while d > -3 and d < 3 do
    d = rnd(-8, 8)
  end while

--  a = rnd(1.38, 1.41) b = .3

  vars = set_variable(vars, {"a", "b", "c", "d"},
                            --{rnd(.9, 1.1), 0, 0, 0})
                            {a, b, c, d})
  vars = set_variable(vars, {"auto_xl", "auto_yl", "auto_zl", 
                             "auto_xh", "auto_yh", "auto_zh"},
                            {1000000, 1000000, 1000000,
                             -1000000, -1000000, -1000000})
  vars = set_variable(vars, {"iterations", "iter", "x", "y", "lyap_sum", "out_hit", "in_hit"},
                            {iterations, 0, -.1, 0, 0, 0, 0})
  vars = set_variable(vars, {"min_r", "min_i", "delta_x", "delta_y"}, 
                            {frac_min[1], frac_min[2], delta[1], delta[2]})
  vars = set_variable(vars, {"lyap", "dim", "status"},
                            {0.02, 0, 0})
  if atom(vars[1]) then
    text_mode()
    puts(1, vars[2] & "\n")
    abort(0)
  end if  
end procedure

procedure draw_step()
  call(fractal_clear)
  init()
  call(fractal_engine)
--  call(fractal_copy)
--    text_mode() 
--    show_vars(vars)
--    abort(0)
--  current_page = -1--grab_page()  --Must be done! fp_copy loses current page
--  text_mode()
--  ? get_variable(vars, "lyap")
--  ? get_variable(vars, "dim")
--  ? get_variable(vars, "delta_x")
--  ? get_variable(vars, "delta_y")
end procedure


--outer loop
--init_queue(8192)
--show_mouse()
--init_cursor()
--set_equipotential(-100)
while get_key() = -1 do
  draw_step()
end while 
  text_mode()
show_vars(vars)
  ? get_variable(vars, "lyap_result")
--  ? get_variable(vars, "dim")
--  ? get_variable(vars, "dim_result")
--  ? get_variable(vars, "status")




