-----------------------------
-- BGET.E             v1.0 --
-- (c) 1999 Gabriel Boehme --
-- doesn't require Euphoria 2.1+ --
-----------------------------

--modified for bsprint(), bsget()     -- 4/99 Nick Metcalfe

include get.e
include machine.e

type string(sequence s) -- string8
object x
   for i = 1 to length(s) do
      x = s[i]
      if integer(x) then
         if x < 0 then
            return 0
         elsif x > #FF then
            return 0
         end if
      else
         return 0
      end if
   end for
   return 1
end type

integer stype, atype, Byte, counter
atom sign, a

sequence data, result

constant ZERO = 0, BYTE = 1, INT16 = 2, INT32 = 4, FLOAT64 = 8
                -- -BYTE #F, -INT16 #E, -INT32 #C
constant NONE = 0, SEQUENCE = 1, STRING = 2


procedure sPrint(object x)
integer len
sequence s
   if atom(x) then                       --atom
      sign = compare(x, 0) --sign
      a = x * sign --absolute value
      if integer(a) then
         if a = 0 then
            atype = ZERO
            s = {}
         elsif a <= #FF then
            atype = BYTE * sign
            s = {a}
         elsif a <= #FFFF then
            atype = INT16 * sign
            s = {remainder(a,#100), floor(a/#100)}
         else
            atype = INT32 * sign
            s = int_to_bytes(a)
         end if
      elsif a = floor(a) and a <= #FFFFFFFF then
         atype = INT32 * sign
         s = int_to_bytes(a)
      else
         atype = FLOAT64
         s = atom_to_float64(x)
      end if
      if atype < 0 then
         atype = atype + #10
      end if
      if stype then
         atype = atype + stype * #10
         stype = NONE
      end if
      result = result & prepend(s, atype)
   else                          --string
      s = x
      len = length(s)
      if string(s) then
         stype = STRING
         sPrint(len)
         result = result & s
      else
         stype = SEQUENCE
         sPrint(len)
         for i = 1 to len do
            sPrint(s[i])
         end for
      end if
   end if
end procedure

global function bsprint(object x)
   stype = NONE
   result = {}
   sPrint(x)
   return result
end function


function sGet()
integer len
sequence s, g
   if length(data) = 0 then
      return {GET_EOF}
   end if
      
   Byte = data[counter]
   counter = counter + 1
   atype = remainder(Byte, #10)
   stype = floor(Byte/#10)
   
   if atype > FLOAT64 then
      atype = #10 - atype
      sign = -1
   else
      sign = 1
   end if
   
   if atype = ZERO then
      a = 0
   elsif atype = BYTE then
      a = data[counter]
      counter = counter + 1
      if a = -1 then
         return {GET_EOF, 0}
      end if
      a = a * sign
   elsif atype = INT16 then
      s = data[counter..counter + 1]
      counter = counter + 2
      a = (s[1] + s[2] * #100) * sign
   elsif atype = INT32 then
      s = data[counter..counter + 3]
      counter = counter + 4
      a = bytes_to_int(s) * sign
   elsif atype = FLOAT64 then
      s = data[counter..counter + 7]
      counter = counter + 8
      a = float64_to_atom(s)
   else
      return {GET_FAIL, Byte}
   end if
   
   if stype then
      len = a
      if stype = STRING then
         s = data[counter..counter + len - 1]
         counter = counter + len
      elsif stype = SEQUENCE then
         s = repeat(0, len)
         for i = 1 to len do
            g = sGet()
            if g[1] != GET_SUCCESS then
               return g
            end if
            s[i] = g[2]
         end for
      else
         return {GET_FAIL, Byte}
      end if
      
      return {GET_SUCCESS, s}
   else
      return {GET_SUCCESS, a}
   end if
end function

global function bsget(object x)
   counter = 1
   data = x
   return sGet()
end function


